import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.JsonNode;
import com.mashape.unirest.http.Unirest;
import com.mashape.unirest.http.exceptions.UnirestException;

public class YouAreEll {
    static Console console;
    static IdOperations idController;
    static MessageOperations messageController;
    static String url;
    static Message message;

    YouAreEll() {
        console = new Console();
        idController = new IdOperations();
        messageController = new MessageOperations();
        url = "http://zipcode.rocks:8085";
    }

    public static void main(String[] args) {
        YouAreEll urlhandler = new YouAreEll();
        /*System.out.println(urlhandler.MakeURLCall("http://zipcode.rocks:8085/ids", "GET", ""));
        System.out.println(urlhandler.MakeURLCall("http://zipcode.rocks:8085/messages", "GET", ""));*/

        String choice = console.printMenu();
        while(choice != null) {
            switch (choice) {
                case "1":
                    postIds();
                    break;
                case "2":
                    get_ids();
                    break;
                case "3":
                    postMessages();
                    break;
                case "4":
                    get_messages();
                    break;
                case "5":
                    putId();
                    break;
                case "6":
                    System.exit(0);
            }
            choice = console.printMenu();
        }
    }

    public static String get_ids() {
        try {
            HttpResponse<JsonNode> jsonResponse = Unirest.get(url + "/ids")
                    .header("accept", "application/json")
                    .asJson();
            console.printAll(jsonResponse.getBody());
            return jsonResponse.getBody().toString();

        } catch (UnirestException e) {
            return "Error";
        }
    }

    public static void postIds() {
        try {
            Unirest.post(url + "/ids")
                    .header("accept", "application/json")
                    .body(idController.createId().toString())
                    .asJson();
        } catch (UnirestException e) {
            e.printStackTrace();
        }
    }

    public static void putId(){
        try {
            Unirest.put(url + "/ids")
                    .header("accept", "application/json")
                    .body(idController.updateId())
                    .asJson();
        } catch (UnirestException e) {
            e.printStackTrace();
        }
    }

    public static String get_messages() {
        try {
            HttpResponse<JsonNode> jsonResponse = Unirest.get(url + "/messages")
                    .header("accept", "application/json")
                    .asJson();

            console.printAll(jsonResponse.getBody());
            return jsonResponse.getBody().toString();

        } catch (UnirestException e) {
            return "Error";
        }
    }

    private static void messageGenerator(){
        message = messageController.createMessage();
    }

    public static void postMessages() {
        messageGenerator();
        try {
            Unirest.post(url + "/ids/" + message.getFromid() + "messages")
                    .header("accept", "application/json")
                    .body(message.toString())
                    .asJson();
        } catch (UnirestException e) {
            e.printStackTrace();
        }
    }
}
